/******************************************************************************/
/*	apci35s.h																  */
/*																			  */
/*	aPCI-A35															  */
/*																			  */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									  */
/*																			  */
/*	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B					  */
/*																			  */
/******************************************************************************/
#pragma once

#include <windows.h>
#include "Apci35w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

namespace SampleA35
{
	/// <summary> 
	/// Apci35s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Apci35s : public System::Windows::Forms::Form
	{
	public: 
		Apci35s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Apci35w* A35w;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Apci35s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = S"Apci35s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"aPCI-A35 Sample";
			this->Load += new System::EventHandler(this, Apci35s_Load);

		}		
		private: System::Void Apci35s_Load(System::Object *  sender, System::EventArgs *  e)
		{
			int		dwDllVer, dwDrvVer;
			bool	bResult;				// 
			short	wLogSlot;				// foCXi[
			Byte	b;
			Apci35w::Resource* ri;			// \[X
			int		dwSwitchValue;			// [^XCb`̒l
			Apci35w::SampleParams* param;	// TvOp[^
			short	wSmpData;				// TvOf[^
			String* szbuf;
			int		i;

			A35w  = new Apci35w;
			param = new Apci35w::SampleParams;
			ri    = new Apci35w::Resource;
			ri->dwMemBase		= new Int32[Apci35w::MAX_MEM];
			ri->dwMemLength		= new Int32[Apci35w::MAX_MEM];
			ri->dwMemAttrib		= new Int32[Apci35w::MAX_MEM];
			ri->dwIOPortBase	= new Int32[Apci35w::MAX_IO];
			ri->dwIOPortLength	= new Int32[Apci35w::MAX_IO];
			ri->dwIRQRegisters	= new Int32[Apci35w::MAX_IRQ];
			ri->dwIRQAttrib		= new Int32[Apci35w::MAX_IRQ];
			ri->dwDMALst		= new Int32[Apci35w::MAX_DMA];
			ri->dwDMAAttrib		= new Int32[Apci35w::MAX_DMA];
			ri->dwReserved1		= new Int32[Apci35w::MAX_RSV];

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Apci35w::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Apci35w::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Apci35w::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Apci35w::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci35w::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			/*---------------------------------------------------------------------------*/
			// o[Wԍ\
			// aPCI-A35 DLL,Drṽo[Wԍ擾
			if (A35w->GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci35w::SLOT_AUTO);
				return;
			}
			szbuf = String::Concat(S"GetVersion\n",
									String::Format(S"DLL: 0x{0}\n", dwDllVer.ToString("x8")),
									String::Format(S"DRV: 0x{0}",   dwDrvVer.ToString("x8")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// aPCI-A35̎gp錾
			wLogSlot = Apci35w::SLOT_AUTO;		// gp̃foCXT܂B
			bResult = A35w->Create(&wLogSlot);	// ꍇA̎̃foCXi[܂B
			if (bResult == false) {				// foCX܂B
				ErrorMessage(Apci35w::SLOT_AUTO);
				return;
			}
			szbuf = String::Concat(S"Created\n\n",
									String::Format(S"LogSlot: {0}", wLogSlot.ToString("d")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// \[X擾
			if (A35w->GetResource(wLogSlot, ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}

			/*---------------------------------------------------------------------------*/
			// [^XCb`̒l擾
			if (A35w->GetSwitchValue(wLogSlot, &dwSwitchValue) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szbuf = String::Concat(String::Format(S"IO Address : 0x{0} - 0x{1}\n",
													ri->dwIOPortBase[0].ToString("x4"),
													(ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1).ToString("x4")),
									String::Format(S"Switch    : 0x{0}",
													dwSwitchValue.ToString("x")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// TvO
			param->dwSamplingChannel = 1;	// TvOs`l (1`8)
			param->dwResolution = 12;		// \(8 or 12 bits)
			if (A35w->StartSampling(wLogSlot, param, &wSmpData) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szbuf = String::Concat(S"TvOf[^\n",
									String::Format(S"Data: {0}h", wSmpData.ToString("x3")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// Cӂ̃f[^o
			b = 0x55;
			if (A35w->OutPort(wLogSlot, b) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szbuf = String::Concat(S"f[^o\n",
									String::Format(S"Out Data: {0}h", b.ToString("x2")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// f[^ǂݍ
			b = 0x00;
			if (A35w->InPort(wLogSlot, &b) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szbuf = String::Concat(S"f[^\n",
									String::Format(S"In Data: {0}h", b.ToString("x2")));
			ResultMessage(szbuf);

			/*---------------------------------------------------------------------------*/
			// aPCI-A35̎gpJ
			if (A35w->Close(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage(S"Closed");
			this->Close();
		}

		// ʂ\
		private: void ResultMessage(String* pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		// װүނ\
		private: void ErrorMessage(short wLogSlot)
		{
			int dwRes = A35w->GetLastError(wLogSlot);
			String* szbuf;

			switch (dwRes) {
				case Apci35w::ERR_WRAPDLL:
				case Apci35w::ERR_SYSTEM:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szbuf = String::Concat(S"System error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
				default:
					szbuf = String::Concat(S"aPCI-A35 error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szbuf, S"aPCI-A35 ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}
