/*============================================================================
//	aPCI-A35 Tv\tgQ
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//  TvF
//		źނ͂AaPCI-A35߰Ăɓo͂s܂B
//
//		ͺ:
//			I		EXIT
//			A/D			A A/D
//			oͺ		O  ް
//			ͺ		I 
//			Aͺ	RIN
//
//		uAPCICTRL.CvƁuSAMPLE2.CvRpC^NĂgpB
//
//	߲ٕ@F
//		TC++4.0̏ꍇ	tcc -ml sample2.c apcictrl.c
//		MS-C6.0̏ꍇ	cl /AL sample2.c apcictrl.c
//
//	ӁF
//	@{vOTC++4.0/MS-C6.0œmFsĂ܂B
//	̑RpCgp̏ꍇ̓TvvȌCKvɂȂꍇ
//	L܂B
//	@{vO͂lr|cnrœ\Ȏst@C𐶐łRpC
//	ł̂݃RpC\łB
//
//	{{[h͂`ohbQP𓋍ڂĂ܂
//
//==========================================================================*/
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <string.h>
#include "typedef.h"
#include "apci35.h"

#define	APCI35_MAX_PORTS	4				/* o߰Đ */
#define	SAMPLE_MODE			12				/* 12Bit */
/*============================================================================
//	A/Dِݒ
//==========================================================================*/
boolean SetSampleCh( LPAPCI_FIND_RES Rsp, int iCh )
{
int		iCnt;
uchar	cbChst;

	ApciOutPort( Rsp, APCI35_CHIN, (uchar)iCh );	/* ِݒ */
	for ( iCnt=20000; iCnt != 0; --iCnt){			/* ݸޏI҂ */
		cbChst = ApciInPort( Rsp, APCI35_CHIN );
		if ( 0 != ( APCI35_CHST & cbChst ) )		/* ݸޏIH */
			break;
	}
	return( ( 0 != iCnt ) ? TRUE : FALSE );
}
/*============================================================================
//	A/DϊJnƏI҂
//==========================================================================*/
boolean SampleStart( LPAPCI_FIND_RES Rsp, int iMode )
{
int		iCnt;
uchar	cbSts;

	if ( 12 == iMode )
		ApciOutPort( Rsp, APCI35_ADSTA12, 0 );		/* 12Bit A/Dϊ */
	else
		ApciOutPort( Rsp, APCI35_ADSTA8, 0 );		/* 8Bit A/Dϊ */

	for ( iCnt=20000; iCnt != 0; --iCnt ){
		cbSts = ApciInPort( Rsp, APCI35_STSIN );
		if (0 == ( APCI35_STS & cbSts ) )			/* A/DϊIH */
			break;
	}
	return( ( 0 != iCnt ) ? TRUE : FALSE);
}
/*============================================================================
//	A/Dlǂݍ
//==========================================================================*/
ushort GetSampleData( LPAPCI_FIND_RES Rsp, int iMode )
{
struct	_byte 		{ uchar	low,high; };
union	_byte_uni 	{ struct _byte b;ushort w; } Data;

	if (12 == iMode){
		Data.b.low  = ApciInPort( Rsp, APCI35_ADL );	/* 12Bit A/Dް擾 */
		Data.b.high = ApciInPort( Rsp, APCI35_ADH );
		Data.w >>= 4;
	} else {
		Data.b.low  = ApciInPort( Rsp, APCI35_ADH );	/* 8Bit A/Dް擾 */
		Data.b.high = 0;
	}
	return( Data.w );
}
/*============================================================================
//	A/Dl擾
//==========================================================================*/
boolean GetSample( LPAPCI_FIND_RES Rsp, int iCh, int iMode, ushort *pwData )
{
boolean	bRes;

	bRes = SetSampleCh( Rsp, iCh );					/* A/Dِݒ */
	if ( TRUE == bRes ){
		bRes = SampleStart( Rsp, iMode );			/* A/Dݸ޽ */
		if ( TRUE == bRes )
			*pwData = GetSampleData( Rsp, iMode );	/* A/Dް擾 */
	}
	return( bRes );
}
/*============================================================================
//	A/Dͺޏ
//==========================================================================*/
void ApciAdIn( LPAPCI_FIND_RES Rsp, char *szStr, int iMaxCh )
{
int		iCh;
ushort	wDat;

	if (1 == sscanf( szStr, "%d", &iCh) ){				/* َ擾 */
		if ( 0 <= iCh && iCh < iMaxCh ){				/* ͈ٔ͊mF */
			if (TRUE == GetSample( Rsp, iCh, SAMPLE_MODE, &wDat))	/* A/D擾 */
				printf( " A/D CH%d  IN:%03X ", iCh, wDat );	/* ް\ */
			else
				printf( " A/D CH%d Sampling Error", iCh );
		} else {
			printf( " Ch Error" );						/* ٴװ */
		}
	} else {
		printf( " Error" );								/* Ұװ */
	}
}
/*============================================================================
//	oͺޏ
//==========================================================================*/
void ApciOut( LPAPCI_FIND_RES Rsp, char *szStr, int iMaxPort )
{
int		iPort;
ushort	wDat;

	if (2 == sscanf( szStr, "%d %x", &iPort, &wDat) ){	/* قް擾 */
		if ( 0 <= iPort && iPort < iMaxPort ){			/* ͈ٔ͊mF */
			if ( wDat < 0x100 ){
				ApciOutPort( Rsp, iPort, (uchar)wDat );	/* wقްo */
				printf( " I/O Base+%d OUT:%02X", iPort, wDat );	/* oް\ */
			} else {
				printf( " Data Error" );				/* data װ */
			}
		} else {
			printf( " Port Error" );					/* ٴװ */
		}
	} else {
		printf( " Error" );								/* Ұװ */
	}
}
/*============================================================================
//	ͺޏ
//==========================================================================*/
void ApciIn( LPAPCI_FIND_RES Rsp, char *szStr, int iMaxPort )
{
int		iPort;
uchar	cbDat;

	if (1 == sscanf( szStr, "%d", &iPort) ){			/* َ擾 */
		if ( 0 <= iPort && iPort < iMaxPort ){			/* ͈ٔ͊mF */
			cbDat = ApciInPort( Rsp, iPort );			/* wٓ */
			printf( " I/O Base+%d IN:%02X ", iPort, cbDat );	/* ް\ */
		} else {
			printf( " Port Error" );					/* ٴװ */
		}
	} else {
		printf( " Error" );								/* Ұװ */
	}
}
/*============================================================================
//	Aͺޏ
//==========================================================================*/
void ApciRepeatIn( LPAPCI_FIND_RES Rsp )
{
int		iCh;
ushort	wInAd[APCI35_MAX_ADCH],wDat;
uchar	cbDat;
char	szBuf[18];

	printf("\n");
	for ( iCh=0; iCh < APCI35_MAX_ADCH; iCh++ )
		printf( "  A/D CH%d ", iCh );
	printf( "      EXT" );
	printf("\n");
	for ( iCh=0; iCh < (APCI35_MAX_ADCH+1); iCh++ )
		printf( "----------");
	printf("\n");

	while(!kbhit()){
		for (iCh=0; iCh < APCI35_MAX_ADCH; iCh++){
			if (TRUE == GetSample( Rsp, iCh, SAMPLE_MODE, &wDat))
				wInAd[iCh] = wDat;
		}
		cbDat = ApciInPort( Rsp, APCI35_EXIN );

		printf("\r");
		for (iCh=0; iCh < APCI35_MAX_ADCH; iCh++)
			printf("  %3Xh ",wInAd[iCh] );
		printf(" %08s ",itoa( cbDat, szBuf, 2) );
	}
	getch();
}
/*============================================================================
//	Ҳ
//==========================================================================*/
void main(void)
{
APCI_FIND_RES hA35;
ushort	wRes;
char	szStr[80];

	if ( ApciGetDriverFunc() != -1 ) {			/* ذ擾 */
												/* ޲擾 */
		wRes = ApciGetDeviceInfo( &hA35, APCI35_BOARD_ID, 0 );
		if ( wRes == CMD_COMPLETE ) {			/* 擾ł */
			while(1){
				printf( "\n>" );
				gets(szStr);					/* ޓ */
				if ( 0 == strcmpi( "EXIT", szStr ))				/* EXIT */
					break;
				else if ( 0 == strnicmp( "A ", szStr, 2 ))		/* A/D IN */
					ApciAdIn( &hA35, &szStr[2], APCI35_MAX_ADCH );
				else if ( 0 == strnicmp( "O ", szStr, 2 ))		/* OUT */
					ApciOut( &hA35, &szStr[2], APCI35_MAX_PORTS );
				else if ( 0 == strnicmp( "I ", szStr, 2 ))		/* IN */
					ApciIn( &hA35, &szStr[2], APCI35_MAX_PORTS );
				else if ( 0 == strnicmp( "RIN", szStr, 3 ))		/* RIN */
					ApciRepeatIn( &hA35 );
				else if ( 0 == strcmpi( "?", szStr )){
					printf( " I     ... EXIT\n" );
					printf( " A/D  ... A A/D\n" );
					printf( " o     ... O ߰ ް\n" );
					printf( "      ... I ߰\n" );
					printf( " A ... RIN\n" );
					printf( "          A/Dق 0`%d",APCI35_MAX_ADCH-1 );
					printf( "          ߰Ă     0`%d",APCI35_MAX_PORTS-1 );
				}
				else if ( '\0' != szStr[0] )
					printf( " Command Error" );
			}
		}
		else {
			printf( "޲܂\n" );
		}
	}
	else {
		printf( "ײނ̴ذ擾ł܂ł\n" );
	}
}
