'*****************************************************************************
'* apci35s.vb                                                                *
'*                                                                           *
'* aPCI-A35                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'*  ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B                   *
'*                                                                           *
'*****************************************************************************

Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Public Class Form1
    Inherits System.Windows.Forms.Form

    Dim A35w As Apci35w

#Region " Windows tH[ fUCiŐꂽR[h "

    Public Sub New()
        MyBase.New()

        ' ̌Ăяo Windows tH[ fUCiŕKvłB
        InitializeComponent()

        ' InitializeComponent() Ăяǒɏǉ܂B

    End Sub

    ' Form ́AR|[lgꗗɌ㏈s邽߂ dispose I[o[Ch܂B
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Windows tH[ fUCiŕKvłB
    Private components As System.ComponentModel.IContainer

    '  : ȉ̃vV[ẂAWindows tH[ fUCiŕKvłB
    'Windows tH[ fUCigĕύXĂB  
    ' R[h GfB^gĕύXȂłB
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 12)
        Me.ClientSize = New System.Drawing.Size(292, 266)
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "aPCI-A35 Sample"

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim strbuf As String
        Dim dwDllVer As Integer, dwDrvVer As Integer
        Dim bResult As Boolean              ' 
        Dim wLogSlot As Short               ' foCXi[
        Dim b As Byte
        Dim ri As Apci35w.Resource          ' \[X
        Dim dwSwitchValue As Integer        ' [^XCb`̒l
        Dim param As Apci35w.SampleParams   ' TvOp[^
        Dim wSmpData As Short               ' TvOf[^
        Dim i As Integer

        ' 
        A35w = New Apci35w
        param = New Apci35w.SampleParams
        ri = New Apci35w.Resource
        ri.dwMemBase = New Integer(Apci35w.MAX_MEM) {}
        ri.dwMemLength = New Integer(Apci35w.MAX_MEM) {}
        ri.dwMemAttrib = New Integer(Apci35w.MAX_MEM) {}
        ri.dwIOPortBase = New Integer(Apci35w.MAX_IO) {}
        ri.dwIOPortLength = New Integer(Apci35w.MAX_IO) {}
        ri.dwIRQRegisters = New Integer(Apci35w.MAX_IRQ) {}
        ri.dwIRQAttrib = New Integer(Apci35w.MAX_IRQ) {}
        ri.dwDMALst = New Integer(Apci35w.MAX_DMA) {}
        ri.dwDMAAttrib = New Integer(Apci35w.MAX_DMA) {}
        ri.dwReserved1 = New Integer(Apci35w.MAX_RSV) {}

        ' 
        ri.dwNumMemWindows = 0
        For i = 0 To Apci35w.MAX_MEM
            ri.dwMemBase(i) = 0
            ri.dwMemLength(i) = 0
            ri.dwMemAttrib(i) = 0
        Next
        ri.dwNumIOPorts = 0
        For i = 0 To Apci35w.MAX_IO
            ri.dwIOPortBase(i) = 0
            ri.dwIOPortLength(i) = 0
        Next
        ri.dwNumIRQs = 0
        For i = 0 To Apci35w.MAX_IRQ
            ri.dwIRQRegisters(i) = 0
            ri.dwIRQAttrib(i) = 0
        Next
        ri.dwNumDMAs = 0
        For i = 0 To Apci35w.MAX_DMA
            ri.dwDMALst(i) = 0
            ri.dwDMAAttrib(i) = 0
        Next
        For i = 0 To Apci35w.MAX_RSV
            ri.dwReserved1(i) = 0
        Next

        '---------------------------------------------------------------------------
        ' o[Wԍ\
        If A35w.GetVersion(dwDllVer, dwDrvVer) = False Then
            ErrorMessage(Apci35w.SLOT_AUTO)
            Exit Sub
        End If
        strbuf = String.Concat("GetVersion", vbCrLf, _
                                String.Format("DLL Version: &H{0:X8}", dwDllVer), vbCrLf, _
                                String.Format("DRV Version: &H{0:X8}", dwDrvVer))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' aPCI-A35̎gp錾
        wLogSlot = Apci35w.SLOT_AUTO     ' gp̃foCXT܂B

        ' ꍇA̎̃foCXi[܂B
        bResult = A35w.Create(wLogSlot)
        If bResult = False Then         ' foCX܂B
            ErrorMessage(Apci35w.SLOT_AUTO)
            Exit Sub
        End If

        strbuf = String.Concat("Created", vbCrLf, vbCrLf, _
                                String.Format("LogSlot: {0}", wLogSlot))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' \[X擾
        If A35w.GetResource(wLogSlot, ri) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        '---------------------------------------------------------------------------
        ' [^XCb`̒l擾
        If A35w.GetSwitchValue(wLogSlot, dwSwitchValue) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        strbuf = String.Concat(String.Format("IO Address: &H{0:X4} - {1:X4}", _
                                                ri.dwIOPortBase(0), ri.dwIOPortBase(0) + ri.dwIOPortLength(0) - 1), vbCrLf, _
                                String.Format("Switch Value: &H{0:X}", dwSwitchValue))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' TvO
        param.dwSamplingChannel = 1     ' TvOs`l (1`8)
        param.dwResolution = 12         ' \(8 or 12 bits)
        If A35w.StartSampling(wLogSlot, param, wSmpData) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        strbuf = String.Concat("TvOf[^", vbCrLf, _
                                String.Format("Data: &H{0:X}", wSmpData))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' Cӂ̃f[^o
        b = &HAA
        If A35w.OutPort(wLogSlot, b) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        strbuf = String.Concat("f[^o", vbCrLf, _
                                String.Format("Out Data: &H{0:X2}", b))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' f[^ǂݍ
        b = &H0
        If A35w.InPort(wLogSlot, b) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If

        strbuf = String.Concat("f[^", vbCrLf, _
                                String.Format("In Data: &H{0:X2}", b))
        ResultMessage(strbuf)

        '---------------------------------------------------------------------------
        ' aPCI-A35̎gpJ
        If A35w.Close(wLogSlot) = False Then
            ErrorMessage(wLogSlot)
            Exit Sub
        End If
        ResultMessage("Closed")
        Me.Close()
    End Sub

    ' ʂ\
    Private Sub ResultMessage(ByVal lpszbuf As String)
        MsgBox(lpszbuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Information, Me.Text)
    End Sub

    ' G[bZ[W\
    Private Sub ErrorMessage(ByVal wLogSlot As Short)
        Dim dwRes As Integer
        Dim szBuf As String

        dwRes = A35w.GetLastError(wLogSlot)
        Select Case dwRes
            Case Apci35w.ERR_SYSTEM, Apci35w.ERR_WRAPDLL
                dwRes = System.Runtime.InteropServices.Marshal.GetLastWin32Error()
                szBuf = String.Concat("System error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:X8}", dwRes))
            Case Else
                szBuf = String.Concat("aPCI-A35 error", vbCrLf, vbCrLf, _
                                        String.Format("Error code: &H{0:X8}", dwRes))
        End Select
        MsgBox(szBuf, MsgBoxStyle.OKOnly + MsgBoxStyle.Critical, Me.Text)
    End Sub

End Class
