Attribute VB_Name = "Wrapper"
'*****************************************************************************
'* apci35w.bas                                                               *
'*                                                                           *
'* aPCI-A35                                                              *
'*                                                                           *
'* Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.                                   *
'*                                                                           *
'*****************************************************************************
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI35_DLL_NAME = "apci35.dll" ' DLL

Dim hDLL As Long                'DLLւ̃nh

Global Const APCI35_ERR_WRAPDLL = -1  ' bp[֐G[

'*****************************************************************************
'*    apci35.dll[h                                                 *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wDllOpen() As Boolean

    Apci35wDllOpen = False

    If hDLL <> 0 Then Exit Function

    hDLL = LoadLibrary(APCI35_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Apci35wGetDllExportFunc() = False Then
        Apci35wDllClose     ' DLL GNX|[g֐LmFɎŝŁADLL N[Y
        Exit Function
    End If

    Apci35wDllOpen = True

End Function

'*****************************************************************************
'*    apci35.dllA[h                                             *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wDllClose() As Boolean

    Apci35wDllClose = True

    If hDLL = 0 Then Exit Function

    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Apci35wDllClose = False

End Function

'*****************************************************************************
'*    aPCI-A35 DLL,Drṽo[Wԍ擾                               *
'*    pdwDllVer DLLo[Wԍi[                              *
'*        pdwDrvVer Drvo[Wԍi[                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wGetVersion(pdwDllVer As Long, pdwDrvVer As Long) As Boolean

    Apci35wGetVersion = False

    If hDLL = 0 Then Exit Function

    If Apci35GetVersion(pdwDllVer, pdwDrvVer) = 0 Then Exit Function
        
    Apci35wGetVersion = True

End Function

'*****************************************************************************
'*    aPCI-A35̔Cӂ̃foCX̎gp錾                               *
'*    pwLogSlot  gpfoCXi[                                  *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wCreate(pwLogSlot As Integer) As Boolean

    Apci35wCreate = False
    
    If hDLL = 0 Then Exit Function

    If Apci35Create(pwLogSlot) = 0 Then Exit Function
        
    Apci35wCreate = True

End Function

'*****************************************************************************
'*    aPCI-A35̔Cӂ̃foCX̎gpJ                               *
'*    wLogSlot gpfoCX                                          *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wClose(wLogSlot As Integer) As Boolean

    Apci35wClose = False

    If hDLL = 0 Then Exit Function

    If Apci35Close(wLogSlot) = 0 Then Exit Function
    
    Apci35wClose = True

End Function

'*****************************************************************************
'*    wfoCX̃\[X擾                                   *
'*    wLogSlot ׂfoCX                                            *
'*        pres     \[Xi[\                              *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wGetResource(wLogSlot As Integer, pres As APCI35RESOURCE) As Boolean

    Apci35wGetResource = False
    
    If hDLL = 0 Then Exit Function

    If Apci35GetResource(wLogSlot, pres) = 0 Then Exit Function
    
    Apci35wGetResource = True

End Function

'*****************************************************************************
'*    [^XCb`̒l擾                                         *
'*    wLogSlot       ׂfoCX                                      *
'*        pdwSwitchValue [^XCb`̒l                                *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wGetSwitchValue(wLogSlot As Integer, pdwSwitchValue As Long) As Boolean

    Apci35wGetSwitchValue = False

    If hDLL = 0 Then Exit Function
    
    If Apci35GetSwitchValue(wLogSlot, pdwSwitchValue) = 0 Then Exit Function

    Apci35wGetSwitchValue = True

End Function

'*****************************************************************************
'*    A/DTvO̎s                                              *
'*    wLogSlot       TvOfoCX                            *
'*        pcpara         TvOp[^                              *
'*        pwSamplingData TvOf[^                                  *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wStartSampling(wLogSlot As Integer, pcpara As APCI35PARA, pwSamplingData As Integer) As Boolean

    Apci35wStartSampling = False

    If hDLL = 0 Then Exit Function

    If Apci35StartSampling(wLogSlot, pcpara, pwSamplingData) = 0 Then Exit Function

    Apci35wStartSampling = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gf[^                                       *
'*    wLogSlot  ͂foCX                                         *
'*        pbInValue ̓f[^i[                                         *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wInPort(wLogSlot As Integer, pbInValue As Byte) As Boolean

    Apci35wInPort = False

    If hDLL = 0 Then Exit Function

    If Apci35InPort(wLogSlot, pbInValue) = 0 Then Exit Function
    
    Apci35wInPort = True

End Function

'*****************************************************************************
'*    Cӂ̃|[gփf[^o                                         *
'*    wLogSlot  o͂foCX                                         *
'*        bOutValue o͂f[^                                           *
'* ߂l  True                                                          *
'*        s False                                                         *
'*****************************************************************************
Function Apci35wOutPort(wLogSlot As Integer, bOutValue As Byte) As Boolean


    Apci35wOutPort = False

    If hDLL = 0 Then Exit Function

    If Apci35OutPort(wLogSlot, bOutValue) = 0 Then Exit Function
    
    Apci35wOutPort = True

End Function

'*****************************************************************************
'*    aPCI-A35̃G[R[h                                             *
'*    wLogSlot  G[foCX                                 *
'* ߂l G[R[h                                                       *
'*****************************************************************************
Function Apci35wGetLastError(wLogSlot As Integer) As Long


    Apci35wGetLastError = APCI35_ERR_WRAPDLL

    If hDLL = 0 Then Exit Function

    Apci35wGetLastError = Apci35GetLastError(wLogSlot)

End Function

'*---------------------------------------------------------------------------*
'*    DLLGNX|[g֐L̊mF                                      *
'*                                                                   *
'* ߂l  True                                                          *
'*        s False                                                         *
'*---------------------------------------------------------------------------*
Private Function Apci35wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    
    Apci35wGetDllExportFunc = False
    
    ' Apci35GetVersion ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35GetVersion")
    If pFunc = 0 Then Exit Function

    ' Apci35Create ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35Create")
    If pFunc = 0 Then Exit Function

    ' Apci35Close ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35Close")
    If pFunc = 0 Then Exit Function

    ' Apci35GetResource ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35GetResource")
    If pFunc = 0 Then Exit Function

    ' Apci35GetSwitchValue ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35GetSwitchValue")
    If pFunc = 0 Then Exit Function

    ' Apci35StartSampling ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35StartSampling")
    If pFunc = 0 Then Exit Function

    ' Apci35InPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35InPort")
    If pFunc = 0 Then Exit Function

    ' Apci35OutPort ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35OutPort")
    If pFunc = 0 Then Exit Function

    ' Apci35GetLastError ̃AhX擾
    pFunc = GetProcAddress(hDLL, "Apci35GetLastError")
    If pFunc = 0 Then Exit Function

    Apci35wGetDllExportFunc = True  ' SĂ DLL GNX|[g֐݂̑mF


End Function
