/*****************************************************************************/
/*	apci35w.h																 */
/*																			 */
/*	aPCI-A35															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	Date 1998/06/26															 */
/*																			 */
/*****************************************************************************/

#ifndef __APCI35W_H__
#define __APCI35W_H__

#include "apci35.h"


#ifdef __cplusplus
extern "C"{
#endif


#define APCI35_DLL_NAME	  _T("apci35.dll")	// DLL


#define APCI35_ERR_WRAPDLL ((DWORD)-1)	// bp[֐G[


BOOL  Apci35wDllOpen();			// DLL [h
BOOL  Apci35wDllClose();		// DLL A[h

BOOL  Apci35wGetVersion(PDWORD pdwDllVer, PDWORD pdwDrvVer);

BOOL  Apci35wCreate(PWORD pwLogSlot);	// CӂaPCI-A35̎gp錾
BOOL  Apci35wClose(WORD wLogSlot);		// CӂaPCI-A35̎gpJ

BOOL  Apci35wGetResource(WORD wLogSlot, PAPCI35R pres);			// \[X擾

BOOL  Apci35wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue);
BOOL  Apci35wStartSampling(WORD wLogSlot, PAPCI35P pcpara, PWORD pwSamplingData);

BOOL  Apci35wInPort(WORD wLogSlot, PBYTE pbInValue);	// f[^
BOOL  Apci35wOutPort(WORD wLogSlot, BYTE bOutValue);	// f[^o

DWORD Apci35wGetLastError(WORD wLogSlot);	// aPCI-A35̃G[R[h


#ifdef __cplusplus
}
#endif

#endif // __APCI35W_H__
